import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;
import org.junit.jupiter.params.provider.ValueSource;

class whileExercisesTest {

	public static whileExercises testObject;
	
	public static int[][] sumArrayData = {
			{1,2,3},
			{1,2,3,4},
			{5,5,5,5,5},
			{6,8,3,5,1,1,8}
	};
	public static int[] sumArrayResult = {6,10,25,32};

	public static int[][] squareArrayData = {
			{1,2},
			{1,2,3},
			{1,2,3,4},
			{5,5,5},
			{1,1,1,2,2,2}
	};
	public static int[] squareArrayResult = {5,14,30,75,15};

	@BeforeAll
	static void setUpBeforeClass() throws Exception {
		testObject = new whileExercises();
	}

	@ParameterizedTest
	@DisplayName("Testing sumIntegerArray")
	@ValueSource(ints = {0,1,2,3})
	void testSumIntegerArray(int testNo) {
		assertEquals(sumArrayResult[testNo], testObject.sumIntegerArray(sumArrayData[testNo]));
	}
	
	@ParameterizedTest
	@DisplayName("Testing countVowels")
	@CsvSource({"Alphabet,3","Sausages,4", "November,3", "Object Oriented Programming,9"})
	void testCountVowels(String aString, int expectedVowels) {
		assertEquals(expectedVowels, testObject.countVowels(aString));
	}

	@ParameterizedTest
	@DisplayName("Testing sumOfSquares")
	@ValueSource(ints = {0,1,2,3,4})
	void testSumOfSquares(int testNo) {
		assertEquals(squareArrayResult[testNo], testObject.sumOfSquares(squareArrayData[testNo]));
	}
}
